////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             OVM Tutorial             s////
////s           gopi@testbenh.in           s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

class seq_act_mac_ovm_do extends ovm_sequence #(instruction);

  instruction req;
 
  function new(string name="seq_act_mac_ovm_do");
    super.new(name);
  endfunction
  
  `ovm_sequence_utils(seq_act_mac_ovm_do, instruction_sequencer)    

  virtual task body();
      ovm_report_info(get_full_name(),"Executing Sequence Action Macro ovm_do",OVM_LOW);
      `ovm_do(req)
  endtask
  
endclass 


class seq_act_mac_ovm_do_with extends ovm_sequence #(instruction);

  instruction req;
 
  function new(string name="seq_act_mac_ovm_do_with");
    super.new(name);
  endfunction
  
  `ovm_sequence_utils(seq_act_mac_ovm_do_with, instruction_sequencer)    

  virtual task body();
      ovm_report_info(get_full_name(),"Executing Sequence Action Macro ovm_do_with ",OVM_LOW);
      `ovm_do_with(req,{ inst == ADD; })
  endtask
  
endclass 


class seq_act_mac_ovm_create_and_ovm_send extends ovm_sequence #(instruction);

  instruction req;
 
  function new(string name="seq_act_mac_ovm_create_and_ovm_send");
    super.new(name);
  endfunction
  
  `ovm_sequence_utils(seq_act_mac_ovm_create_and_ovm_send, instruction_sequencer)    

  virtual task body();
      ovm_report_info(get_full_name(),"Executing Sequence Action Macro ovm_create and ovm_send",OVM_LOW);
      `ovm_create(req)
      req.inst = instruction::PUSH_B;
      `ovm_send(req)
  endtask
  
endclass 

class seq_act_mac_ovm_create_and_ovm_rand_send extends ovm_sequence #(instruction);

  instruction req;
 
  function new(string name="seq_act_mac_ovm_create_and_ovm_rand_send");
    super.new(name);
  endfunction
  
  `ovm_sequence_utils(seq_act_mac_ovm_create_and_ovm_rand_send, instruction_sequencer)    

  virtual task body();
      ovm_report_info(get_full_name(),"Executing Sequence Action Macro ovm_create and ovm_rand_send",OVM_LOW);
      `ovm_create(req)
      `ovm_rand_send(req)
  endtask
  
endclass 

